--[[ $Id: EasyTrack.lua 50862 2007-10-04 02:42:00Z hshh $ ]]--
EasyTrack = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceEvent-2.0", "AceHook-2.1", "AceConsole-2.0")
local bs = AceLibrary("Babble-Spell-2.2")
local L = AceLibrary("AceLocale-2.2"):new("EasyTrack")

L:RegisterTranslations("enUS", function() return {
	["Reset"] = true,
	["Reset all settings."] = true,
	["Auto Show"] = true,
	["Auto show menu while mouse enter icon."] = true,
	["Hide Delay time"] = true,
	["Set menu auto hide delay time."] = true,
	["All settings are reset to default."] = true,
	["Menu Anchor Point"] = true,
	["Setup menu anchor point."] = true,
	["Menu Anchor Relative Point"] = true,
	["Setup menu anchor relative point."] = true,
	["TOPRIGHT"] = true,
	["TOPLEFT"] = true,
	["BOTTOMRIGHT"] = true,
	["BOTTOMLEFT"] = true,
	["TOP"] = true,
	["BOTTOM"] = true,
	["LEFT"] = true,
	["RIGHT"] = true,
	["CENTER"] = true,
	["Replace Low Level Spell"] = true,
	["Replace low level spell with higher one."] = true,
} end )

L:RegisterTranslations("zhCN", function() return {
	["Reset"] = "重置",
	["Reset all settings."] = "重置所有设置",
	["Auto Show"] = "自动显示",
	["Auto show menu while mouse enter icon."] = "当鼠标移动到跟踪状态图标时自动显示图标.",
	["Hide Delay time"] = "自动隐藏延迟",
	["Set menu auto hide delay time."] = "设置菜单自动隐藏的延迟时间.",
	["All settings are reset to default."] = "所有设置已经重置到默认参数.",
	["Menu Anchor Point"] = "菜单锚点",
	["Setup menu anchor point."] = "设置菜单锚点",
	["Menu Anchor Relative Point"] = "菜单相对锚点",
	["Setup menu anchor relative point."] = "设置菜单相对锚点",
	["TOPRIGHT"] = "右上",
	["TOPLEFT"] = "左上",
	["BOTTOMRIGHT"] = "右下",
	["BOTTOMLEFT"] = "左下",
	["TOP"] ="上",
	["BOTTOM"] = "下",
	["LEFT"] = "左",
	["RIGHT"] = "右",
	["CENTER"] = "中",
	["Replace Low Level Spell"] = "替换低等级法术",
	["Replace low level spell with higher one."] = "使用高等级法术代替低等级的",
} end )

L:RegisterTranslations("koKR", function() return {
	["Reset"] = "초기화",
	["Reset all settings."] = "모든 설정 초기화",
	["Auto Show"] = "자동 보이기",
	["Auto show menu while mouse enter icon."] = "아이콘 위에 마우스를 위치시기면 목록을 자동으로 보입니다.",
	["Hide Delay time"] = "사라지는데 지연 시간 설정",
	["Set menu auto hide delay time."] = "자동 목록이 사라지는데 걸리는 지연 시간을 설정합니다.",
	["All settings are reset to default."] = "모든 설정을 기본값으로 초기화 합니다.",
} end )

local SpellList = {
	["COMMON"] = {
		"Find Herbs",
		"Find Minerals",
		"Find Treasure",
	},
	["HUNTER"] = {
		"Track Beasts",
		"Track Demons",
		"Track Dragonkin",
		"Track Elementals",
		"Track Giants",
		"Track Hidden",
		"Track Humanoids",
		"Track Undead",
		"Aspect of the Beast",
		"Aspect of the Cheetah",
		"Aspect of the Hawk",
		"Aspect of the Monkey",
		"Aspect of the Pack",
		"Aspect of the Viper",
		"Aspect of the Wild",
		"Trueshot Aura",
	},
	["WARLOCK"] = {
		"Sense Demons",
		"Summon Imp",
		"Summon Voidwalker",
		"Summon Succubus",
		"Eye of Kilrogg",
		"Summon Felhunter",
		"Summon Felsteed",--lv40
		"Inferno",
		"Summon Felguard",
		"Summon Dreadsteed",--lv60
	},
	["PALADIN"] = {
		"Sense Undead",
		"Summon Warhorse",--lv40
		"Summon Charger",--lv60
		"Concentration Aura",
		"Devotion Aura",
		"Fire Resistance Aura",
		"Frost Resistance Aura",
		"Retribution Aura",
		"Shadow Resistance Aura",
		"Sanctity Aura",
	},
	["DRUID"] = {
		"Teleport: Moonglade",
		"Track Humanoids",
	},
	["MAGE"] = {
		"Teleport: Darnassus",
		"Teleport: Exodar",
		"Teleport: Ironforge",
		"Teleport: Orgrimmar",
		"Teleport: Shattrath",
		"Teleport: Silvermoon",
		"Teleport: Stormwind",
		"Teleport: Thunder Bluff",
		"Teleport: Undercity",
		"Portal: Darnassus",
		"Portal: Exodar",
		"Portal: Ironforge",
		"Portal: Orgrimmar",
		"Portal: Shattrath",
		"Portal: Silvermoon",
		"Portal: Stormwind",
		"Portal: Thunder Bluff",
		"Portal: Undercity",
	},
	["SHAMAN"] = {
		"Astral Recall",
		"Lightning Shield",
		"Disease Cleansing Totem",
		"Earthbind Totem",
		"Fire Nova Totem",
		"Fire Resistance Totem",
		"Flametongue Totem",
		"Frost Resistance Totem",
		"Grace of Air Totem",
		"Grounding Totem",
		"Healing Stream Totem",
		"Magma Totem",
		"Mana Spring Totem",
		"Mana Tide Totem",
		"Nature Resistance Totem",
		"Poison Cleansing Totem",
		"Searing Totem",
		"Sentry Totem",
		"Stoneclaw Totem",
		"Stoneskin Totem",
		"Strength of Earth Totem",
		"Tremor Totem",
		"Windfury Totem",
		"Windwall Totem",
		"Tranquil Air Totem",
	}
}
local SpellListReplace = {
	[bs["Summon Dreadsteed"]] = bs["Summon Felsteed"],
	[bs["Summon Charger"]] = bs["Summon Warhorse"],
}


function EasyTrack:OnInitialize()
	self.MaxButton = 25
	self.ValidSpell = 0
	self:RegisterDB("EasyTrack_Settings")
	self:RegisterDefaults("profile", {
		autoHide = 3,
		showOnIconEnter = true,
		anchorPoint = "TOPRIGHT",
		anchorRelativePoint = "BOTTOMLEFT",
		replaceLowLevelSpell = true,
	})
	self:RegisterChatCommand(
		{ "/easytrack", "/et" },
		{
			type = "group",
			args = {
				autoshow = {
					order = 100,
					type = "toggle",
					name = L["Auto Show"],
					desc = L["Auto show menu while mouse enter icon."],
					get = function() return self.db.profile.showOnIconEnter end,
					set = function(t) self.db.profile.showOnIconEnter = t end,
				},
				replace_low_level_spell = {
					order = 150,
					type = "toggle",
					name = L["Replace Low Level Spell"],
					desc = L["Replace low level spell with higher one."],
					get = function() return self.db.profile.replaceLowLevelSpell end,
					set = function(t)
						self.db.profile.replaceLowLevelSpell = t
						self:InitButton()
					end,
				},
				hide_delay = {
					order = 200,
					type = "range",
					name = L["Hide Delay time"],
					min = 1,
					max = 20,
					step = 1,
					desc = L["Set menu auto hide delay time."],
					get = function() return self.db.profile.autoHide end,
					set = function(r)
						self.db.profile.autoHide=r
					end
				},
				anchor_point = {
					order = 300,
					type = "text",
					name = L["Menu Anchor Point"],
					desc = L["Setup menu anchor point."],
					validate = {
						["TOPRIGHT"]=L["TOPRIGHT"], ["TOPLEFT"]=L["TOPLEFT"],
						["BOTTOMRIGHT"]=L["BOTTOMRIGHT"], ["BOTTOMLEFT"]=L["BOTTOMLEFT"],
						["TOP"]=L["TOP"], ["BOTTOM"]=L["BOTTOM"], ["LEFT"]=L["LEFT"],
						["RIGHT"]=L["RIGHT"], ["CENTER"]=L["CENTER"]
						},
					get = function() return self.db.profile.anchorRelativePoint end,
					set = function(t) self.db.profile.anchorRelativePoint = t end,
					usage = "<Anchor Points String>"
				},
				anchor_relative_point = {
					order = 400,
					type = "text",
					name = L["Menu Anchor Relative Point"],
					desc = L["Setup menu anchor relative point."],
					validate = {
						["TOPRIGHT"]=L["TOPRIGHT"], ["TOPLEFT"]=L["TOPLEFT"],
						["BOTTOMRIGHT"]=L["BOTTOMRIGHT"], ["BOTTOMLEFT"]=L["BOTTOMLEFT"],
						["TOP"]=L["TOP"], ["BOTTOM"]=L["BOTTOM"], ["LEFT"]=L["LEFT"],
						["RIGHT"]=L["RIGHT"], ["CENTER"]=L["CENTER"]
						},
					get = function() return self.db.profile.anchorPoint end,
					set = function(t) self.db.profile.anchorPoint = t end,
					usage = "<Anchor Points String>"
				},
				reset = {
					order = 1000,
					type = "execute",
					name = L["Reset"],
					desc = L["Reset all settings."],
					func = function()
						self:ResetDB("profile")
						self:Print(L["All settings are reset to default."])
					end
				},
			}
		}
	)

	self.spellList = {}
	for _, v in ipairs(SpellList["COMMON"]) do
		self.spellList[bs[v]]=bs:GetSpellIcon(v)
	end
	local _,engClass = UnitClass("player")
	if SpellList[engClass] then
		for _, v in ipairs(SpellList[engClass]) do
			self.spellList[bs[v]]=bs:GetSpellIcon(v)
		end
	end
end

function EasyTrack:OnEnable()
	self:InitButton()
	self:HookScript(MiniMapTrackingFrame, "OnEvent", "MiniMapTrackingFrame_OnEvent")
	self:HookScript(MiniMapTrackingFrame, "OnMouseUp", "MiniMapTrackingFrame_OnMouseUp")
	self:HookScript(MiniMapTrackingFrame, "OnEnter", "MiniMapTrackingFrame_OnEnter")
	self:RegisterEvent("SPELLS_CHANGED", "InitButton")
	self:RegisterEvent("LEARNED_SPELL_IN_TAB", "InitButton")
	self:RegisterEvent("PLAYER_REGEN_DISABLED") --in battle
end
function EasyTrack:OnDisable()
	if not GetTrackingTexture() then
		MiniMapTrackingFrame:Hide()
	end
	EasyTrackFrame:Hide()
end

function EasyTrack:MiniMapTrackingFrame_OnEvent()
	if event == "PLAYER_AURAS_CHANGED" then
		local icon = GetTrackingTexture()
		if ( icon ) then
			MiniMapTrackingIcon:SetTexture(icon)
			MiniMapTrackingFrame:Show()
		elseif self.ValidSpell > 0 then
			MiniMapTrackingIcon:SetTexture("Interface\\Icons\\INV_Misc_Map_01")
			MiniMapTrackingFrame:Show()
		else
			MiniMapTrackingFrame:Hide()
		end
	end
end
function EasyTrack:MiniMapTrackingFrame_OnMouseUp()
	if arg1 == "LeftButton" then
		GameTooltip:Hide()
		self:FrameShow()
		return
	end
	return self.hooks[MiniMapTrackingFrame]["OnMouseUp"]()
end
function EasyTrack:MiniMapTrackingFrame_OnEnter()
	if self.db.profile.showOnIconEnter then
		self:FrameShow(true)
		GameTooltip:SetOwner(EasyTrackFrame, "ANCHOR_TOPRIGHT")
		GameTooltip:SetTrackingSpell()
		return
	elseif EasyTrackFrame:IsVisible() then
		return
	end
	return self.hooks[MiniMapTrackingFrame]["OnEnter"]()
end

function EasyTrack:FrameOnShow()
	self:ScheduleRepeatingEvent("EasyTrackFrameHide", self.FrameHide, self.db.profile.autoHide)
end
function EasyTrack:FrameOnEnter(button)
	if self:IsEventScheduled("EasyTrackFrameHide") then
		self:CancelScheduledEvent("EasyTrackFrameHide")
	end
	if button then
		local spell = this:GetText()
		if spell then
			EasyTrackFrameSpellIcon:SetTexture(self.spellList[spell])
			EasyTrackFrameSpellIcon:Show()
		end
	end
end
function EasyTrack:FrameOnLeave()
	if not self:IsEventScheduled("EasyTrackFrameHide") then
		self:ScheduleRepeatingEvent("EasyTrackFrameHide", self.FrameHide, self.db.profile.autoHide)
	end
	EasyTrackFrameSpellIcon:Hide()
end

function EasyTrack:FrameHide()
	if EasyTrack:IsEventScheduled("EasyTrackFrameHide") then
		EasyTrack:CancelScheduledEvent("EasyTrackFrameHide")
	end
	EasyTrackFrame:Hide()
end
function EasyTrack:FrameShow(force)
	if EasyTrackFrame:IsVisible() and not force then
		if self:IsEventScheduled("EasyTrackFrameHide") then
			self:CancelScheduledEvent("EasyTrackFrameHide")
		end
		EasyTrackFrame:Hide()
		return
	end
	EasyTrackFrame:ClearAllPoints()
	EasyTrackFrame:SetPoint(self.db.profile.anchorPoint, MiniMapTrackingFrame, self.db.profile.anchorRelativePoint)
	EasyTrackFrame:Show()
end

function EasyTrack:InitButton()
	local numTotalSpells = 0
	for i=1, MAX_SKILLLINE_TABS do
		local name, _, _, numSpells = GetSpellTabInfo(i)
		if name then
			numTotalSpells = numTotalSpells + numSpells
		end
	end

	local SpellListReplace_low = {}
	if self.db.profile.replaceLowLevelSpell then
		for _,v in pairs(SpellListReplace) do
			SpellListReplace_low[v]=0
		end
	end

	local Spell = {}
	local SpellExists = {}
	for i=1, numTotalSpells do
		local spellName = GetSpellName(i, BOOKTYPE_SPELL)
		if spellName and self.spellList[spellName] and not SpellExists[spellName] then
			table.insert(Spell, spellName)
			SpellExists[spellName] = true
			if self.db.profile.replaceLowLevelSpell then
				if SpellListReplace_low[spellName] then
					SpellListReplace_low[spellName]=getn(Spell)
				end
				if SpellListReplace[spellName] and SpellListReplace_low[SpellListReplace[spellName]] and SpellListReplace_low[SpellListReplace[spellName]]>0 then
					table.remove(Spell, SpellListReplace_low[SpellListReplace[spellName]])
				end
			end
		end
	end

	self.ValidSpell = getn(Spell)

	local width = 0
	for i=1, self.MaxButton do
		local button = getglobal("EasyTrackFrame_Button"..i)
		if Spell[i] then
			button:SetText(Spell[i])
			button:SetAttribute("type1", "spell")
			button:SetAttribute("spell", Spell[i])
			button:Show()
			local TextWidth = button:GetTextWidth()
			if TextWidth > width then
				width = TextWidth
			end
		else
			button:SetText("")
			button:SetAttribute("type1", nil)
			button:SetAttribute("spell", nil)
			button:Hide()
		end
	end
	EasyTrackFrame:SetWidth(width + 2 * 15)
	EasyTrackFrame:SetHeight((getn(Spell) + 3) * 12)
end

function EasyTrack:PLAYER_REGEN_DISABLED()
	EasyTrackFrame:Hide()
	if self:IsEventScheduled("EasyTrackFrameHide") then
		self:CancelScheduledEvent("EasyTrackFrameHide")
	end
end
